#
# MerlinWebInterface
#
# Coded by dre (c) 2012
# Support: www.dreambox-tools.info
# E-Mail: dre@dreambox-tools.info
#
# This plugin is open source but it is NOT free software.
#
# This plugin may only be distributed to and executed on hardware which
# is licensed by Dream Multimedia GmbH.
# In other words:
# It's NOT allowed to distribute any parts of this plugin or its source code in ANY way
# to hardware which is NOT licensed by Dream Multimedia GmbH.
# It's NOT allowed to execute this plugin and its source code or even parts of it in ANY way
# on hardware which is NOT licensed by Dream Multimedia GmbH.
#
# If you want to use or modify the code or parts of it,
# you have to keep MY license and inform me about the modifications by mail.

from Components.Sources.Source import Source
from Components.config import config, configfile, ConfigYesNo, ConfigInteger, ConfigSelection, ConfigNumber, ConfigBoolean, ConfigOnOff, ConfigEnableDisable, ConfigSequence
from Components.UsageConfig import *
from enigma import eEnv
import xml.etree.cElementTree

class MerlinPlugins(Source):
	MENU = 0
	def __init__(self, session, func):
		self.func = func
		self.session = session
		Source.__init__(self)

	def handleCommand(self, cmd):
		if self.func is self.MENU:
			print "[MerlinWebInterface]: In Menu"
			self.result = self.getMerlinPlugins()
		else:
			self.result = False
		print result

	def getMerlinPlugins(self):
		merlinPluginsList = []

		self.getEnabledMerlinPlugins(merlinPluginsList)
		
		return merlinPluginsList
	
	def getEnabledMerlinPlugins(self, merlinPluginsList):
		if config.plugins.MerlinWebInterface.enabledreamcc.value == True:
			merlinPluginsList.append(("DreamCC", "dreamcc", "contentMerlinContent"))

	def getText(self):
		self.handleCommand(None)
		if self.result:
			return str(self.result)
		else:
			return ""

	def getList(self):
		self.handleCommand(None)
		list = self.result
		if list is None:
			list = ()

		return list

	text = property(getText)
	list = property(getList)
	lut = {"Name": 0, "Path": 1, "Target": 2}
