//TODOs:
// - simple pages (about, news) umbauen (analog simplePages in core.js)
// - iframe pages umbauen (analog simplePages in core.js)

// Statics
function url() {
	this.tpl               = '';
	this.merlin            = '/merlin';
	this.merlinsettings = "/merlin/web/merlinsettings";
	this.merlinsettingssave = "/merlin/web/merlinsettingssave"; //plus parms
	this.channellistsettings = "/merlin/web/channellistsettings";
	this.channellistsettingssave = "/merlin/web/channellistsettingssave"; //plus parms
	//this.merlinplugins = "/merlin/web/merlinplugins";
	this.merlininfo = "/merlin/web/merlininfo";
	this.merlinmeminfo = "/merlin/web/merlinmeminfo";
};
var URL = new url();
var feedpage = "dm7020hd";

var MerlinCore = Class.create({
	initialize: function(name){
		// Check WebIf Version
		if (typeof core == "undefined"){
			alert("Old WebInterface found!\nPlease update the WebInterface Plugin first.");
		
		} else {
			// Start Merlin WebIf
			// Instantiate all elements
			this.menu = new MerlinMenuController('contentMerlinMenu');
			this.about = new AboutPage('contentMerlinContent');
			this.feed = new FeedPage('contentMerlinContent');
			this.feednav = new FeedNavPage('navContent');
			this.news = new NewsPage('contentMerlinContent');
			this.settingsnav = new MerlinSettingsNavPage('navContent');
			this.settings = new MerlinSettingsController('contentMerlinContent');
			this.channellistsettings = new ChannellistSettingsController('contentMerlinContent');
			this.wiki = new WikiPage('contentMerlinContent');
			//this.plugins = new PluginsPage('contentMerlinContent'); // to be updated as a left navi is required
			this.infonav = new InfoNavPage('navContent');
			this.meminfo = new MemoryInfoController('contentMerlinContent');

			// Display menu
			this.menu.load();
			// Register Events
			this.registerEvents();
		}
	},
	
	registerEvents: function(){
		var contentmerlin = $('contentMerlinContent');
		contentmerlin.on(
			'click',
			'.mSettingsButton',
			function(event, element){
				this.settings.save($('settingsEditForm'));
			}.bind(this)
		);
		contentmerlin.on(
			'click',
			'.mChannellistSettingsButton',
			function(event, element){
				this.channellistsettings.save($('settingsEditForm'));
			}.bind(this)
		);
		
		var contentmerlinnavi = $('navContent');
		contentmerlinnavi.on(
			'click',
			'.boxfeed',
			function(event, element){
				var device = core.deviceInfo.info.devicename;
				this.setFeedPage(device);
				this.feed.load($('contentMerlinContent'));
			}.bind(this)
		);
		contentmerlinnavi.on(
			'click',
			'.all',
			function(event, element){
				this.setFeedPage("all");
				this.feed.load($('contentMerlinContetnt'));
			}.bind(this)
		);
		contentmerlinnavi.on(
			'click',
			'.mipsel',
			function(event, element){
				var device = core.deviceInfo.info.devicename;
				var mipselfeed = "mips32el"
				if (device == "dm800") {
					mipselfeed = "mips32el-nf";
				}
				this.setFeedPage(mipselfeed);
				this.feed.load($('contentMerlinContent'));
			}.bind(this)
		);
		contentmerlinnavi.on(
			'click',
			'.third-party',
			function(event, element){
				this.setFeedPage("third-party");
				this.feed.load($('contentMerlinContent'));
			}.bind(this)
		);
		
		contentmerlinnavi.on(
			'click',
			'.merlinsettings',
			function(event, element){
				this.settings.loadList($('contentMerlinContent'));
			}.bind(this)
		);
		
		contentmerlinnavi.on(
			'click',
			'.channellistsettings',
			function(event, element){
				this.channellistsettings.loadList($('contentMerlinContent'));
			}.bind(this)
		);
	},
	
	getFeedPage: function(){
		return feedpage;
	},
	
	resetNavigation: function(id, text){
		
		$(id).update('<div class="block center fullwidth oneliner>' + text + '</div>');
	},
	
	setFeedPage: function(dir){
		feedpage = dir;
	}
	
});

var MerlinMenuController  = Class.create(Controller, {
	initialize: function($super, target){
		$super(new MerlinMenuHandler(target));
	},
	
	back: function(){
		window.location = window.location.protocol + "//" + window.location.hostname;
	},
	
	load: function(){
		this.handler.load({});
	},
	
	feed: function(){
		merlincore.feednav.load();
		merlincore.feed.load();
	},
	
	about: function(){
		merlincore.about.load();
	},
	
	news: function(){
		merlincore.news.load();
	},
	
	settings: function(){
		merlincore.settingsnav.load();
		merlincore.settings.loadList();
	},
	
	wiki: function(){
		merlincore.wiki.load();
	},
	
	merlininfo: function(){
		merlincore.infonav.load();
		merlincore.meminfo.loadList();
	},
	
	plugins: function(){
		merlincore.plugins.load();
	},
	
	registerEvents: function(){
		$('back').on(
			'click',
			function(event, element){
				this.back();
			}.bind(this)
		);
		$('back').title = "Return to Dreambox Webcontrol";

		$('feed').on(
			'click',
			function(event, element){
				this.feed();
			}.bind(this)
		);
		$('feed').title = "Show Merlin Feed";
		
		$('news').on(
			'click',
			function(event, element){
				this.news();
			}.bind(this)
		);
		$('news').title = "Show Merlin News";
		
		$('settings').on(
			'click',
			function(event, element){
				this.settings();
				//this.settings.loadList.bind(this.settings);
			}.bind(this)
		);
		$('settings').title = "Show Merlin Settings";

		$('wiki').on(
			'click',
			function(event, element){
				this.wiki();
			}.bind(this)
		);
		$('wiki').title = "Show Merlin Wiki";
		
		/*$('plugins').on(
			'click',
			function(event, element){
				this.plugins();
			}.bind(this)
		);
		$('plugins').title = "Show Merlin Plugins";*/
		
		$('merlininfo').on(
			'click',
			function(event, element){
				this.merlininfo();
			}.bind(this)
		);
		$('merlininfo').title = "Show Merlin info";
		
		$('about').on(
			'click',
			function(event, element){
				this.about();
			}.bind(this)
		);
		$('about').title = "Some information about author, license, support...";
	},
	
	onFinished: function(){
		merlincore.news.load();
	}
});

var AboutPage = Class.create({
	initialize: function(target){
		this.simpleHandler = new SimplePageHandler(target);
	},

	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},

	load: function(){
		merlincore.resetNavigation('navContent','');
		$('navHd').innerHTML = "Merlin About";
		$('headermerlincontent').innerHTML = "Merlin WebIf About";
		this.show('tplAbout');
	},
});

var NewsPage = Class.create({
	initialize: function(target){
		this.simpleHandler = new SimplePageHandler(target);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		merlincore.resetNavigation('navContent','');
		$('navHd').innerHTML = "Merlin-News";
		$('headermerlincontent').innerHTML = "Merlin-News";
		this.show('tplMerlinNews');
	},
});

var PluginsPage = Class.create({
	initialize: function(target){
		this.simpleHandler = new SimplePageHandler(target);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		merlincore.resetNavigation('navContent','');
		$('navHd').innerHTML = "Merlin-Plugins";
		$('headermerlincontent').innerHTML = "Merlin-Plugins";
		this.show('tplMerlinPlugins');
	},
});

var FeedNavPage = Class.create({
	initialize: function(nav){
		this.simpleHandler = new SimplePageHandler(nav);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		$('navHd').innerHTML = "Merlin-Feeds";
		this.show('tplNaviMerlinFeed');
	},
	
});

var FeedPage = Class.create({
	initialize: function(content){
		this.simpleHandler = new SimplePageHandler(content);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		$('headermerlincontent').innerHTML = "Merlin-Feeds";
		this.show('tplMerlinFeed');
	},
});

var WikiPage = Class.create({
	initialize: function(target){
		this.simpleHandler = new SimplePageHandler(target);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		merlincore.resetNavigation('navContent','');
		$('navHd').innerHTML = "Merlin-Wiki";
		$('headermerlincontent').innerHTML = "Merlin-Wiki";
		this.show('tplMerlinWiki');
		},
	});
	
var InfoNavPage = Class.create({
	initialize: function(nav){
		this.simpleHandler = new SimplePageHandler(nav);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		$('navHd').innerHTML = "Merlin-Info";
		this.show('tplNaviMerlinInfo');
	},
});

var MemoryInfoController = Class.create(Controller, {
	initialize: function($super, target){
		$super(new MemDevicesListHandler(target));
		//this.memdeviceshandler = new MemDevicesHandler(target, this.loadList.bind(this), []);
	},
	
	loadList: function(){
		$('headermerlincontent').innerHTML = "Merlin-Info: Memory";
		this.handler.load({});
	},
});

var MerlinMenuHandler = Class.create(AbstractContentHandler,{
	initialize: function($super, target){
		$super('tplMerlinMenu', target);
		this.provider = new SimpleRequestProvider();
	},
	
	load: function(){
		this.show({});
	},
	
});

var MerlinSettingsNavPage = Class.create({
	initialize: function(nav){
		this.simpleHandler = new SimplePageHandler(nav);
	},
	
	show: function(tpl, data){
		if(!data)
			data = {};
		this.simpleHandler.show(tpl, data);
	},
	
	load: function(){
		$('navHd').innerHTML = "Merlin-Settings";
		this.show('tplNaviMerlinSettings');
	},
});

var MerlinSettingsController = Class.create(Controller, {
	initialize: function($super, target){
		$super(new MerlinSettingsListHandler(target));
		this.merlinsettingshandler = new MerlinSettingsHandler(target, this.loadList.bind(this), []);
	},
	
	loadList: function(){
		//merlincore.resetNavigation('navContent','');
		//$('navHd').innerHTML = "Merlin-Settings";
		$('headermerlincontent').innerHTML = "Merlin-Settings";
		this.handler.load({});
	},
	
	save: function(element){
		debug("MerlinSettingsController.save");
		//alert(element);
		
		this.merlinsettingshandler.commitForm(element);
	}
});

var MerlinSettingsListHandler = Class.create(AbstractContentHandler, {
	initialize: function($super, target){
		$super('tplMerlinSettings', target);
		this.provider = new MerlinSettingsListProvider(this.show.bind(this));
		this.ajaxload = true;
	}
});

var MerlinSettingsHandler = Class.create(AbstractContentHandler, {
	initialize: function($super, target, reloadCallback, onFinished){
		$super('tplMerlinSettings', target, onFinished);
		this.m = {};
		this.provider = new SimpleRequestProvider();
		this.ajaxload = true;
		this.reloadCallback = reloadCallback;
		this.dat = {};
	},
	
	simpleResultCallback: function(transport, callback){
		this.provider.simpleResultCallback(
			transport,
			function(result){
				this.showSimpleResult(result, callback);
			}.bind(this)
		);
	},
	
	showSimpleResult: function($super, result, callback){
		$super(result);
		if(callback){
			callback(result);
			return;
		} else if(this.reloadCallback){
			this.reloadCallback();
		}
	},
	
	change: function(m){
		var key, confignames="", configvalues="";
		for (key in m){
			if (m.hasOwnProperty(key))
			{
				if (confignames == "")
				{
					confignames = confignames + key;
					configvalues = configvalues + m[key];
				}
				else
				{
					confignames = confignames + "," + key;
					configvalues = configvalues + "," + m[key];
				}
			}
		}

		var parms = {
			'confignames' : confignames,
			'configvalues' : configvalues,
		};
		
		this.provider.simpleResultQuery(
			URL.merlinsettingssave,
			parms,
			this.simpleResultCallback.bind(this)
		);
	},
	
	commitForm: function(id){
		debug("MerlinSettingsHandler.commitForm");
		// as the serialize thing is not working for me (or I'm just too stupid), I use a little hack
		// by assigning the class MerlinSetting to all elements...
		var merlinsettings = new Array();
		$$('.MerlinSetting').each(function(element){
			merlinsettings[ element.name ] = element.value;
			}
		);

		this.change(merlinsettings);
	},
	
	renderXML: function(xml){
		var list = new MerlinSettingsList(xml).getArray();
		return {merlinsettings : list};
	}
});

var MerlinSettingsListProvider = Class.create(AbstractContentProvider, {
	initialize: function($super, showFnc){
		$super(URL.merlinsettings, showFnc);
		},
		
		renderXML: function(xml){
			var list = new MerlinSettingsList(xml).getArray();
			return { merlinsetting : list };
		}
	});

function MerlinSetting(xml, cssclass){
	this.merlinsettingdescription = getNodeContent(xml, 'e2merlinsettingdescription');
	this.merlinsettingconfig = getNodeContent(xml, 'e2merlinsettingconfig');
	this.merlinsettingdefaultvalue = getNodeContent(xml, 'e2merlinsettingdefaultvalue');
	this.merlinsettingvalues = getNodeContent(xml, 'e2merlinsettingvalues');
	//this.merlinsettingvalue = getNodeContent(xml, 'e2merlinsettingvalue');

	this.getColor = function(){
		return this.color;
	};

	this.getMerlinSettingDescription = function(){
		return this.merlinsettingdescription;
	};
	
	this.getMerlinSettingConfig = function(){
		return this.merlinsettingconfig;
	};

	this.getMerlinSettingDefaultValue = function(){
		return this.merlinsettingdefaultvalue
	};

	this.getMerlinSettingValues = function(){
		var array = this.merlinsettingvalues;
		return array;
	};
	
	if( typeof( cssclass ) == undefined ){
		cssclass = 'odd';
	}

	this.json = {
			'e2merlinsettingdescription' : this.getMerlinSettingDescription(),
			'e2merlinsettingconfig' : this.getMerlinSettingConfig(),
			'e2merlinsettingdefaultvalue' : this.getMerlinSettingDefaultValue(),
			'e2merlinsettingvalues' : this.getMerlinSettingValues(),
			//'e2merlinsettingvalue' : this.getMerlinSettingValue(),
			'cssclass' : cssclass,
	};

	this.toJSON = function(){
		return this.json;
	};
}

function MerlinSettingsList(xml){
	this.xmlitems = getNamedChildren(xml, "e2merlinsettings", "e2merlinsetting"); //, "e2merlinsettingvalues");
	this.settingslist = [];

	this.getArray = function(){
		if(this.settingslist.length === 0){
			var cssclass = 'even';
			var len = this.xmlitems.length;
			for(var i=0; i<len; i++){
				cssclass = cssclass == 'even' ? 'odd' : 'even';
				var merlinsetting = new MerlinSetting(this.xmlitems.item(i), cssclass).toJSON();
				this.settingslist.push(merlinsetting);
			}
		}

		return this.settingslist;
	};
}

var ChannellistSettingsController = Class.create(Controller, {
	initialize: function($super, target){
		$super(new ChannellistSettingsListHandler(target));
		this.channellistsettingshandler = new ChannellistSettingsHandler(target, this.loadList.bind(this), []);
	},
	
	loadList: function(){
		$('headermerlincontent').innerHTML = "Channel Settings";
		this.handler.load({});
	},
	
	save: function(element){
		debug("ChannellistSettingsController.save");
		
		this.channellistsettingshandler.commitForm(element);
	}
});

var ChannellistSettingsListHandler = Class.create(AbstractContentHandler, {
	initialize: function($super, target){
		$super('tplChannellistSettings', target);
		this.provider = new ChannellistSettingsListProvider(this.show.bind(this));
		this.ajaxload = true;
	}
});

var ChannellistSettingsHandler = Class.create(AbstractContentHandler, {
	initialize: function($super, target, reloadCallback, onFinished){
		$super('tplChannellistSettings', target, onFinished);
		this.m = {};
		this.provider = new SimpleRequestProvider();
		this.ajaxload = true;
		this.reloadCallback = reloadCallback;
		this.dat = {};
	},
	
	simpleResultCallback: function(transport, callback){
		this.provider.simpleResultCallback(
			transport,
			function(result){
				this.showSimpleResult(result, callback);
			}.bind(this)
		);
	},
	
	showSimpleResult: function($super, result, callback){
		$super(result);
		if(callback){
			callback(result);
			return;
		} else if(this.reloadCallback){
			this.reloadCallback();
		}
	},
	
	change: function(m){
		var key, confignames="", configvalues="";
		for (key in m){
			if (m.hasOwnProperty(key))
			{
				if (confignames == "")
				{
					confignames = confignames + key;
					configvalues = configvalues + m[key];
				}
				else
				{
					confignames = confignames + "," + key;
					configvalues = configvalues + "," + m[key];
				}
			}
		}

		var parms = {
			'confignames' : confignames,
			'configvalues' : configvalues,
		};
		
		this.provider.simpleResultQuery(
			URL.channellistsettingssave,
			parms,
			this.simpleResultCallback.bind(this)
		);
	},
	
	commitForm: function(id){
		debug("ChannellistSettingsHandler.commitForm");
		// as the serialize thing is not working for me (or I'm just too stupid), I use a little hack
		// by assigning the class MerlinSetting to all elements...
		var channellistsettings = new Array();
		$$('.ChannellistSetting').each(function(element){
			channellistsettings[ element.name ] = element.value;
			}
		);

		this.change(channellistsettings);
	},
	
	renderXML: function(xml){
		var list = new ChannellistSettingsList(xml).getArray();
		return {channellistsettings : list};
	}
});

var ChannellistSettingsListProvider = Class.create(AbstractContentProvider, {
	initialize: function($super, showFnc){
		$super(URL.channellistsettings, showFnc);
		},
		
		renderXML: function(xml){
			var list = new ChannellistSettingsList(xml).getArray();
			return { channellistsetting : list };
		}
	});

function ChannellistSetting(xml, cssclass){
	this.merlinsettingdescription = getNodeContent(xml, 'e2merlinsettingdescription');
	this.merlinsettingconfig = getNodeContent(xml, 'e2merlinsettingconfig');
	this.merlinsettingdefaultvalue = getNodeContent(xml, 'e2merlinsettingdefaultvalue');
	this.merlinsettingvalues = getNodeContent(xml, 'e2merlinsettingvalues');
	//this.merlinsettingvalue = getNodeContent(xml, 'e2merlinsettingvalue');

	this.getColor = function(){
		return this.color;
	};

	this.getMerlinSettingDescription = function(){
		return this.merlinsettingdescription;
	};
	
	this.getMerlinSettingConfig = function(){
		return this.merlinsettingconfig;
	};

	this.getMerlinSettingDefaultValue = function(){
		return this.merlinsettingdefaultvalue
	};

	this.getMerlinSettingValues = function(){
		var array = this.merlinsettingvalues;
		return array;
	};
	
	if( typeof( cssclass ) == undefined ){
		cssclass = 'odd';
	}

	this.json = {
			'e2merlinsettingdescription' : this.getMerlinSettingDescription(),
			'e2merlinsettingconfig' : this.getMerlinSettingConfig(),
			'e2merlinsettingdefaultvalue' : this.getMerlinSettingDefaultValue(),
			'e2merlinsettingvalues' : this.getMerlinSettingValues(),
			//'e2merlinsettingvalue' : this.getMerlinSettingValue(),
			'cssclass' : cssclass,
	};

	this.toJSON = function(){
		return this.json;
	};
}

function ChannellistSettingsList(xml){
	this.xmlitems = getNamedChildren(xml, "e2merlinsettings", "e2merlinsetting"); //, "e2merlinsettingvalues");
	this.settingslist = [];

	this.getArray = function(){
		if(this.settingslist.length === 0){
			var cssclass = 'even';
			var len = this.xmlitems.length;
			for(var i=0; i<len; i++){
				cssclass = cssclass == 'even' ? 'odd' : 'even';
				var merlinsetting = new MerlinSetting(this.xmlitems.item(i), cssclass).toJSON();
				this.settingslist.push(merlinsetting);
			}
		}

		return this.settingslist;
	};
}


var MemDevicesListHandler = Class.create(AbstractContentHandler, {
	initialize: function($super, target){
		$super('tplMerlinMemoryInfo', target);
		this.provider = new MemDevicesListProvider(this.show.bind(this));
		this.ajaxload = true;
	}
});

var MemDevicesListProvider = Class.create(AbstractContentProvider, {
	initialize: function($super, showFnc){
		$super(URL.merlinmeminfo, showFnc);
		},
		
		renderXML: function(xml){
			var list = new MerlinMemDevicesList(xml).getArray();
			return { memdevices : list };
		}
	});

function MerlinMemoryInfo(xml, cssclass){
	this.memdevicename = getNodeContent(xml, 'e2memdevicename');
	this.memmountpoint = getNodeContent(xml, 'e2memmountpoint');
	this.memusedspace = getNodeContent(xml, 'e2memusedspace');
	this.memtotalspace = getNodeContent(xml, 'e2memtotalspace');
	this.percused = getNodeContent(xml, 'e2percused');
	
	this.getMemDeviceName = function(){
		return this.memdevicename;
	};
	
	this.getMemMountPoint = function(){
		return this.memmountpoint;
	};
	
	this.getMemUsedSpace = function(){
		return this.memusedspace;
	};
	
	this.getMemTotalSpace = function(){
		return this.memtotalspace;
	};
	
	this.getPercUsed = function(){
		return this.percused;
	};
	
	if( typeof( cssclass ) == undefined ){
		cssclass = 'odd';
	}
	
	this.json = {
		'e2memdevicename' : this.getMemDeviceName(),
		'e2memmountpoint' : this.getMemMountPoint(),
		'e2memusedspace' : this.getMemUsedSpace(),
		'e2memtotalspace' : this.getMemTotalSpace(),
		'e2percused' : this.getPercUsed(),
		'cssclass' : cssclass,
	};
	
	this.toJSON = function(){
		return this.json;
	};
}

function MerlinMemDevicesList(xml){
	this.xmlitems = getNamedChildren(xml, "e2memdevices", "e2memdevice");
	this.memdeviceslist = [];
	
	this.getArray = function(){
		if(this.memdeviceslist.length === 0){
			var cssclass = 'even';
			var len = this.xmlitems.length;
			for(var i=0; i<len; i++){
				cssclass = cssclass == 'even' ? 'odd' : 'even';
				var memdevice = new MerlinMemoryInfo(this.xmlitems.item(i), cssclass).toJSON();
				this.memdeviceslist.push(memdevice);
			}
		}
		return this.memdeviceslist;
	};
}
